<template>
  <main>
    <mt-page-title :with-border="false" with-padding>
      <h1 class="has-text-weight-bold is-size-3">Mes alertes</h1>
    </mt-page-title>
    <mt-box padding="0">
      <mt-alertes
        v-for="(dateAlerte, index) in alertes.content"
        :key="index"
        v-slot="{ item: alerte }"
        :date-alerte="dateAlerte"
      >
        <mt-alerte
          :key="alerte.id"
          :alerte="alerte"
          :titre="alerte.titre"
          :description="alerte.description"
          :commentaire="alerte.commentaire"
        ></mt-alerte>
      </mt-alertes>
      <footer>
        <button v-if="!isAfficherTout" @click="afficherTout">
          Voir plus
        </button>
      </footer>
    </mt-box>
  </main>
</template>

<script>
import MtPageTitle from '~/components/base/page-title/index';
import alerteMixin from '~/components/mixins/alerteMixin';
import MtBox from '~/components/base/box';
import { classResolver } from '~/components/mixins/activityMixin';
import MtAlertes from '~/components/alerte/alertes';
import MtAlerte from '~/components/alerte/alerte';

export default {
  components: {
    MtAlerte,
    MtAlertes,
    MtBox,
    MtPageTitle,
  },
  mixins: [alerteMixin, classResolver],
  data() {
    return {
      isAfficherTout: false,
    };
  },
  computed: {
    alertesTotalNonLu() {
      return this.$store.state.alerte.nonLue;
    },
  },
  async asyncData(context) {
    const alertes = await context.$api.utilisateurs.alertes(20);
    await context.store.dispatch('alerte/setNonLu', alertes);
    return {
      alertes,
    };
  },
  methods: {
    async afficherTout() {
      this.alertes = await this.$api.utilisateurs.alertes(null);
      await this.$store.dispatch('alerte/setNonLu', this.alertes.nonLue);
      this.isAfficherTout = true;
    },
    detailType({ activite }) {
      return this.resolveTypeActivite(activite, 'mt-background-type-');
    },
  },
};
</script>

<style scoped lang="scss">
@import '~/assets/css/_variables';

header {
  padding: 1em;
  font-size: 0.9375rem;
  color: $grey-dark;
}
small {
  color: $grey;
  display: block;
  margin: 1rem 2rem 0.5rem 0;
}
a {
  text-decoration: underline;
}
.non-lu {
  background-color: $alerte-non-lue;
}
footer {
  padding: 15px 0;
  text-align: center;
  font-size: 15px;
  color: $grey-dark;
  button {
    background-color: transparent;
    border: 0 solid transparent;
    cursor: pointer;
  }
  button:hover {
    text-decoration: underline;
  }
}
</style>
